/*
 * myLibS3.h
 *
 *  Created on: Jun 30, 2014
 *      Author: nick
 */

#ifndef _MYLIBS3_H_
#define _MYLIBS3_H_
#include <string>
#include <vector>
#include <set>
#include <iostream>
#include <cstdio>
#include <ctime>
#include <fstream>
#include "libs3.h"

struct S3Obj
{
	std::string key;
	int64_t time;
	uint64_t size;
	std::string tag;
};

struct S3ObjComp
{
	bool operator()(const S3Obj&left, const S3Obj& right) const
	{
		return left.key.compare(right.key) < 0;
	}
};

typedef std::set<S3Obj, S3ObjComp> S3ObjSet;
typedef std::vector<S3Obj> S3ObjVect;

enum SyncDirectionEnum
{
	DirectionNone = 0,
	DirectionUpload = 1,
	DirectionDownload = -1
};

//#define CHECK_STATUS  if (status != S3StatusOK) return false;
S3Status MyS3ResponsePropertiesCallback(const S3ResponseProperties *properties,
		void *callbackData);
void MyS3ResponseCompleteCallback(S3Status status,
				  const S3ErrorDetails *errorDetails,
				  void *callbackData);


#endif /* MYLIBS3_H_ */
